from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n

import time
import os
import commands

class LTVBorder(Sensor):

	def __init__(self, top = "5", bottom = "5", height = "50", default = "0", paths = "gfx/bg/%b.png", names = "none top bottom both"):
		global _; _ = i18n.Translator("ltv-border-sensor")
		self.__paths = paths
		self.__top = int( top )
		self.__bottom = int( bottom )
		self.__height = int( height )
		self.__names = names.split()
		self.__borders = [["None",0],["Top",1],["Bottom",2],["Both",3]]
		Sensor.__init__(self)
		self._set_config_type("type", TYPE_INT, int(default))
		self._watch_config(self.watch_config)
		self._add_timer(0, self.draw)
		
	def get_configurator(self):
		configurator = self._new_configurator()
		configurator.set_name(_("Border"))
		configurator.add_title(_("Border Configuration"))
		configurator.add_option(_("Type:"), "type", _("Style of border you want on the tops and bottoms of the display."),[["None",0],["Top",1],["Bottom",2],["Both",3]])
		return configurator

	def draw(self):
		data = self._new_output()
		height = self.__height
		top = 0
		t = self._get_config("type")
		if t == 1 or t == 3:
			height = height + self.__top
			top = self.__top
		if t == 2 or t == 3:
			height = height + self.__bottom
		data.set("height", height)
		data.set("top", top)
		data.set("background", self.__paths.replace("%b",self.__names[t]))
		self._send_output(data)

	def watch_config(self,key,value):
		self.draw( )

def new_sensor(args): return apply(LTVBorder, args)
