from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n
import time
import os

class LTVFontSelector(Sensor):

	def __init__(self, font_default = "Font|Sans 8|black|0"):
		global _; _ = i18n.Translator("ltv-font-selector-sensor")
		Sensor.__init__(self)
		titles = []
		i = 0
		for font in font_default.split('||') :
			entry = font.split('|')
			titles = titles + [ entry[ 0 ] ]
			self._set_config_type("font%i" % i, TYPE_STRING, entry[1])
			self._set_config_type("color%i" % i, TYPE_STRING, entry[2])
			self._set_config_type("offset%i" % i, TYPE_INT, int(entry[3]))
			i = i + 1
		self.__entries = titles
		self._add_timer(0, self.init_values)
		self._watch_config( self.watch_config )
	
	def init_values(self):
		data = self._new_output()
		i = 0
		while i < len( self.__entries ) :
			data.set( "font%i" % i, self._get_config("font%i" % i).encode("UTF-8"))
			data.set( "color%i" % i, self._get_config("color%i" % i).encode("UTF-8"))
			data.set( "offset%i" % i, self._get_config("offset%i" % i))
			i = i + 1
		self._send_output(data)
	
	def get_configurator(self):
		configurator = self._new_configurator()
		configurator.set_name(_("Fonts"))
		i = 0
		for entry in self.__entries:
			configurator.add_title( entry )
			if self._get_config("font%i" % i) != "NULL" :
				configurator.add_font_selector(_("Font:"), "font%i" % i, _("Set the text color for ") + "\"" + entry + "\"")
			if self._get_config("color%i" % i) != "NULL" :
				configurator.add_color_selector(_("Color:"), "color%i" % i, _("Set the text color for ") + "\"" + entry + "\"")
			if self._get_config("offset%i" % i) != 999 :
				configurator.add_spin(_("Vertical position:"), "offset%i" % i, _("Vertical position of text"), -100, 100)

			i = i + 1
		return configurator
	
	def watch_config(self,key,value):
		if value != "NULL" and value != "999":
			data = self._new_output()
			data.set(key, value)
			self._send_output(data)

def new_sensor(args): return apply(LTVFontSelector, args)
